﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Common.UI
{
    [AttributeUsage(AttributeTargets.Field | AttributeTargets.Property)]
    public sealed class ColumnAttribute : System.Attribute
    {
        public string ColumnName;

        public ColumnAttribute(string columnName)
        {
            this.ColumnName = columnName;
        }
    }

    [AttributeUsage(AttributeTargets.Field | AttributeTargets.Property)]
    public class ThisToManyRelationAttribute : System.Attribute
    {
        public ThisToManyRelationAttribute()
        { }
    }

    [AttributeUsage(AttributeTargets.Field | AttributeTargets.Property)]
    public class ThisToOneRelationAttribute : System.Attribute
    {
        public ThisToOneRelationAttribute()
        { }
    }

    [AttributeUsage(AttributeTargets.Field | AttributeTargets.Property)]
    public sealed class ChildRelationshipAttribute : System.Attribute
    {
        public ChildRelationshipAttribute()
        { }
    }

    /// <summary>
    /// When placed on an object it indicates that the object should be included in the DataObjectTreeView
    /// </summary>
    [AttributeUsage(AttributeTargets.Class)]
    public class TreeViewVisibleAttribute : System.Attribute
    {
        public TreeViewVisibleAttribute()
        {
        }
    }
}
