﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Geometry.Graphics
{
    public struct Color
    {
        public Byte R;
        public Byte G;
        public Byte B;
        public Byte A;

        public Color(Byte r, Byte g, Byte b, Byte a)
        {
            R = r;
            G = g;
            B = b;
            A = a;
        }

        public Color(Byte r, Byte g, Byte b)
        {
            R = r;
            G = g;
            B = b;
            A = 255;
        }

        public Color(double r, double g, double b) : this((byte)(r / (double)byte.MaxValue),
                                                          (byte)(g / (double)byte.MaxValue),
                                                          (byte)(b / (double)byte.MaxValue))
        {

        }

        public Color(double r, double g, double b, double a) : this(r,g,b)
        {
            A = (byte)(a / (double)byte.MaxValue);
        }

        static readonly public Color Blue = new Color(0x00, 0x00, 0xff);
        static readonly public Color Green = new Color(0x00, 0xff, 0x00);
        static readonly public Color Red = new Color(0xff, 0x00, 0x00);
        static readonly public Color Gold = new Color(0xff, 0xd7, 0x00);
    }
}
