﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Viking.Common;
using Viking.ViewModels;

namespace Viking.PropertyPages
{
    [PropertyPage(typeof(SectionViewModel), 1)]
    public partial class SectionGeneralPage : Viking.UI.BaseClasses.PropertyPageBase
    {
        SectionViewModel Obj; 

        public SectionGeneralPage()
        {
            InitializeComponent();
        }

        protected override void OnShowObject(object Object)
        {
            this.Obj = Object as SectionViewModel;
            Debug.Assert(this.Obj != null);

            this.textSectionNumber.Text = Obj.Number.ToString();

            List<int> SectionNumbers = new List<int>(UI.State.volume.SectionViewModels.Keys); 
            SectionNumbers.Sort();

            int ReferenceAbove = int.MaxValue; 
            int ReferenceBelow = int.MinValue; 

            if(Obj.ReferenceSectionAbove != null)
                ReferenceAbove = Obj.ReferenceSectionAbove.Number;

            if (Obj.ReferenceSectionBelow != null)
                ReferenceBelow = Obj.ReferenceSectionBelow.Number; 

            for (int iSection = 0; iSection < SectionNumbers.Count; iSection++)
            {
                int SectionNumber = SectionNumbers[iSection];
                if (SectionNumber < Obj.Number)
                {
                    listBelow.Items.Add(SectionNumber);
                    if (SectionNumber == ReferenceBelow)
                        listBelow.SelectedItem = SectionNumber; 

                }
                else if (SectionNumber > Obj.Number)
                {
                    listAbove.Items.Add(SectionNumber);
                    if (SectionNumber == ReferenceAbove)
                        listAbove.SelectedItem = SectionNumber; 
                }
            }
        }

        protected override void OnSaveChanges()
        {
            if(listAbove.SelectedItem != null)
            {
                Obj.ReferenceSectionAbove = Obj.VolumeViewModel.SectionViewModels[(int)listAbove.SelectedItem].section;
            }

            if(listBelow.SelectedItem != null)
            {
                Obj.ReferenceSectionBelow = Obj.VolumeViewModel.SectionViewModels[(int)listBelow.SelectedItem].section;
            }
            
        }
    }
}
