﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Media;
using System.Windows.Media.Media3D; 
using System.Windows.Data;
using Viking.VolumeViewModel;
using System.Diagnostics;

namespace Viking.VolumeView
{
    class TileViewModelToGeometry3DConverter : IValueConverter
    {
        #region IValueConverter Members

        object IValueConverter.Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            IEnumerable<TileViewModel> tiles = value as IEnumerable<TileViewModel>;
            Debug.Assert(tiles != null);

            Model3DCollection ModelCollection = new Model3DCollection(tiles.Count<TileViewModel>());
            foreach (TileViewModel t in tiles)
            {
                ModelCollection.Add(t.Model);
            }

            return ModelCollection; 
        }

        object IValueConverter.ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
