﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Prism.MefExtensions.Modularity;
using Microsoft.Practices.ServiceLocation;
using Microsoft.Practices.Prism.Regions; 
using System.ComponentModel.Composition;
using Viking.VolumeViewModel; 

namespace Viking.VolumeView
{

    [ModuleExport(typeof(VikingVolumeViewModule), InitializationMode = InitializationMode.WhenAvailable, DependsOnModuleNames = new string[] { "VolumeViewModelModule" })]
    class VikingVolumeViewModule : IModule 
    {
        #region IModule Members

        delegate void InitializeUIDelegate(); 
        
        void IModule.Initialize()
        {
            System.Diagnostics.Trace.WriteLine("VikingVolumeViewModule::Initialize()");


            InitializeUIDelegate InitUIDelegate = new InitializeUIDelegate(InitializeUI);

            System.Windows.Application.Current.Dispatcher.Invoke(InitUIDelegate, null); 
        }

        /// <summary>
        /// The initialization of UI must occur on the STA thread
        /// </summary>
        void InitializeUI()
        {
            IRegionManager regionManager = ServiceLocator.Current.GetInstance<IRegionManager>();
            SectionList sectionList = new SectionList();
//            PyramidViewer pyramidViewer = new PyramidViewer();

//            Viking.VolumeViewModel.VolumeViewModel volume = Microsoft.Practices.ServiceLocation.ServiceLocator.Current.GetInstance<Viking.VolumeViewModel.VolumeViewModel>();
//            SectionViewModel section = volume.SectionViewModels.Values[1];

            //pyramidViewer.TileMapping = section.DefaultMapping; 

            //regionManager.AddToRegion(Jotunn.RegionNames.Navigation, sectionList);
            //regionManager.AddToRegion(Jotunn.RegionNames.View, pyramidViewer);

            regionManager.AddToRegion(Jotunn.RegionNames.View, sectionList);
        }

        #endregion
    }
}
