﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Xml;
using System.Xml.Linq; 

namespace Viking.VolumeModel
{
    class CreateSectionThreadingObj : IDisposable
    {
        public ManualResetEvent DoneEvent = new ManualResetEvent(false);

        readonly Volume volume;
        readonly string SectionPath;
        readonly XElement reader;

        public Section newSection; 

        public CreateSectionThreadingObj(Volume vol, string path, XElement SectionElement)
        {
            this.reader = SectionElement;
            this.volume = vol;
            this.SectionPath = path; 
        }

        public void ThreadPoolCallback(Object threadContext)
        {
            newSection = new Section(volume, SectionPath, reader);

            DoneEvent.Set(); 
        }

        #region IDisposable Members

        public void Dispose()
        {
            DoneEvent.Close(); 
        }

        #endregion
    }
}
