﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Xml.Linq; 
using Geometry;
using System.IO; 

namespace Viking.VolumeModel
{
    class CreateStosGridTransformThreadingObj : IDisposable
    {
        public ManualResetEvent DoneEvent = new ManualResetEvent(false);

        readonly string Path;
        readonly System.Net.NetworkCredential UserCredentials;

        public readonly XElement element;
        readonly Stream stream;

        public StosGridTransform stosTransform;

        public CreateStosGridTransformThreadingObj(Stream stream, XElement reader)
        {
            this.element = reader;
            this.stream = stream; 
        }

        public CreateStosGridTransformThreadingObj(string path, System.Net.NetworkCredential userCreds, XElement reader)
        {
            this.element = reader;
            this.Path = path;
            UserCredentials = userCreds; 
        }

        public void ThreadPoolCallback(Object threadContext)
        {
            if (stream != null)
                stosTransform = new StosGridTransform(stream, element);
            else
                stosTransform = new StosGridTransform(Path, element, UserCredentials); 

            DoneEvent.Set();
            if (stream != null)
            {
                stream.Close(); 
            }
        }

        #region IDisposable Members

        public void Dispose()
        {
            DoneEvent.Close(); 
        }

        #endregion
    }
}
