﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.Prism.Modularity;
using Microsoft.Practices.Prism.MefExtensions.Modularity;
using Microsoft.Practices.ServiceLocation; 
using System.ComponentModel.Composition;
using System.ComponentModel.Composition.Hosting;
using System.Diagnostics;


namespace Viking.VolumeViewModel
{
    [ModuleExport(typeof(VolumeViewModelModule), InitializationMode = InitializationMode.WhenAvailable)]
    public class VolumeViewModelModule : IModule
    {
        #region IModule Members

        [Import]
        Jotunn.IShellParameters ShellParameters { get; set; }

        [Import("InitializeBackgroundWorker")]
        System.ComponentModel.BackgroundWorker InitializeBackgroundWorker { get; set; }

        [Export]
        Viking.VolumeViewModel.VolumeViewModel VolumeViewModel {get;set;} 

        void IModule.Initialize()
        {
            string HostPath = ShellParameters.GetArgTable["HostPath"];

            this.VolumeViewModel = new Viking.VolumeViewModel.VolumeViewModel(HostPath, ShellParameters.GetXML, InitializeBackgroundWorker);                                                                                               
        }

        #endregion
    }
}
