﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Viking.VolumeModel;
using System.Xml.Linq;
using System.ComponentModel.Composition;


namespace Viking.VolumeViewModel
{
    public class VolumeViewModel
    {
        private Volume _Volume;

        public SortedList<int, SectionViewModel> SectionViewModels;

        public string Name { get { return _Volume.Name; } }

        public bool IsLocal { get { return _Volume.IsLocal; } }

        public string DefaultVolumeTransform { get { return _Volume.DefaultVolumeTransform; } }

        public ChannelInfo[] DefaultChannels { get { return _Volume.DefaultChannels; } set { _Volume.DefaultChannels = value; } }

        public string[] ChannelNames { get { return _Volume.ChannelNames; } }

        

 //       public string[] TransformNames { get { return _Volume.Transforms.Keys.ToArray(); } }
               
        public VolumeViewModel(string path, XDocument VolumeXML, System.ComponentModel.BackgroundWorker workerThread)
        {
            _Volume = new Volume(path, Global.CachePath, VolumeXML, workerThread);

            SectionViewModels = new SortedList<int, SectionViewModel>(_Volume.Sections.Length);

            foreach (Section s in _Volume.Sections)
            {
                SectionViewModel sectionViewModel = new SectionViewModel(this, s);
                SectionViewModels.Add(s.Number, sectionViewModel); 
            }

        }

        public string Host { get { return _Volume.Host; } }        
    }
}
