﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WebAnnotation;
using Viking.Common;
using System.Diagnostics;
using WebAnnotationModel;
using WebAnnotation.ViewModel; 

namespace WebAnnotation.UI.Controls
{
    [Viking.Common.SupportedUITypes(typeof(LocationObj))]
    public partial class ListLocations : Viking.UI.BaseClasses.DockingListControl
    {
        Location[] _locations;

        EventHandler LocationCreateEventHandler;
        
        
        public ListLocations()
        {
            this.ListItems.ShowPropertiesOnDoubleClick = false;
            InitializeComponent();

            LocationCreateEventHandler = new EventHandler(OnLocationCreate);
            LocationObj.Create += LocationCreateEventHandler; 
        }

        public void SetLocations(Location[] locations)
        {
            this._locations = locations;

            this.ListItems.DisplayObjects(_locations); 
        }

        protected override void OnObjectDoubleClick(IUIObject obj)
        {
            Location loc = obj as Location;
            Debug.Assert(loc != null);

            //SectionViewerForm.Show(section);
            Viking.UI.State.ViewerForm.GoToLocation(new Microsoft.Xna.Framework.Vector2((float)loc.X, (float)loc.Y), (int)loc.Z, true);

            //BUG: This is because the way I handle commands changed dramatically between Plantmap and Viking.  I need to
            //set selected object to null to keep the UI from doing strange things
            Viking.UI.State.SelectedObject = null; 
        }

        public void OnLocationCreate(object sender, EventArgs e)
        {
            Location loc = sender as Location;
            Debug.Assert(loc != null);
            if(loc != null)
                this.ListItems.AddObject(loc); 

        }

        protected override void parentForm_Closing(object sender, CancelEventArgs e)
        {
            LocationObj.Create -= LocationCreateEventHandler;

            base.parentForm_Closing(sender, e);
        }
    }
}
