﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Viking.Common;
using System.Diagnostics;
using WebAnnotation.ViewModel;
using WebAnnotationModel;

namespace WebAnnotation.UI
{
    [PropertyPage(typeof(Structure), 1)]
    public partial class StructureGeneralPage : Viking.UI.BaseClasses.PropertyPageBase
    {
        Structure Obj; 

        public StructureGeneralPage()
        {
            InitializeComponent();
        }

        protected override void OnInitPage()
        {
            base.OnInitPage();
        }

        protected override void OnShowObject(object Object)
        {
            this.Obj = Object as Structure;
            Debug.Assert(this.Obj != null);

            this.textID.Text= this.Obj.ID.ToString();

            this.checkVerified.Checked = this.Obj.Verified;

            this.numConfidence.Value = System.Convert.ToDecimal(this.Obj.Confidence); 

            this.textNotes.Text = this.Obj.Notes;
            this.textLabel.Text = this.Obj.InfoLabel;

            List<ListViewItem> items = new List<ListViewItem>(this.Obj.Tags.Length);
            foreach (string tag in Obj.Tags)
            {
                items.Add(new ListViewItem(tag));
            }

            this.listTags.Items.AddRange(items.ToArray());
        }

        protected override void OnSaveChanges()
        {
            this.Obj.Verified = this.checkVerified.Checked;
            this.Obj.Confidence = System.Convert.ToDouble(this.numConfidence.Value);
            this.Obj.Notes = this.textNotes.Text;
            this.Obj.InfoLabel = this.textLabel.Text; 

            List<string> Tags = new List<string>(listTags.Items.Count);  
            foreach (ListViewItem item in listTags.Items)
            {
                Tags.Add(item.Text);  
            }

            this.Obj.Tags = Tags.ToArray(); 
        }
    }
}
