﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Viking.Common;
using System.Diagnostics;
using WebAnnotation.ViewModel;
using WebAnnotationModel;

namespace WebAnnotation.UI
{
    [PropertyPage(typeof(Structure), 2)]
    public partial class StructureLocationsPage : Viking.UI.BaseClasses.PropertyPageBase
    {
        Structure Obj; 

        public StructureLocationsPage()
        {
            
            InitializeComponent();
            this.Title = "Locations";
            this.listLocations.Title = "Locations";
            this.listLocations.TitleVisible = false; 
        }

        protected override void OnInitPage()
        {
            base.OnInitPage();
        }

        protected override void OnShowObject(object Object)
        {
            this.Obj = Object as Structure;
            Debug.Assert(this.Obj != null);

            LocationObj[] locations = Store.Structures.GetLocationsForStructure(Obj.ID);
            List<Location> listLocationViews = new List<Location>(locations.Length);

            foreach (LocationObj loc in locations)
            {
                listLocationViews.Add(new Location(loc));
            }

            listLocations.SetLocations(listLocationViews.ToArray()); 

            
        }
    }
}
