﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized; 
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Viking.Common;
using WebAnnotation;
using WebAnnotation.ViewModel;
using WebAnnotationModel; 

namespace WebAnnotation.UI
{
    [ExtensionTabAttribute("Structure Types", TABCATEGORY.ACTION)]
    public partial class StructureTypesTree : Viking.UI.BaseClasses.DockingTreeControl
    {
        public StructureTypesTree()
        {
            InitializeComponent();

            this.Title = "Structure Types";

            //Store.StructureTypes.OnCollectionChanged += this.OnStructureTypeCollectionChanged;
        }

        protected override void InitializeTree()
        {
            ICollection<StructureTypeObj> listTypes = Store.StructureTypes.rootObjects.Values;
            List<StructureType> listRootTypes = new List<StructureType>(listTypes.Count);
            foreach (StructureTypeObj type in listTypes)
            {
                StructureType rootType = new StructureType(type);
                listRootTypes.Add(rootType);
            }

            Tree.AddObjects(listRootTypes.ToArray());
        }

        protected void OnStructureTypeCollectionChanged(object sender, NotifyCollectionChangedEventArgs args)
        {
            /*
            switch (args.ChangeAction)
            {
                case AddUpdateRemoveKeyEventArgs.Action.ADD:
                    Tree.AddObjects(new IUIObject[] { sender as IUIObject }); 
                    
                    break;
            }
            */
        }

        private void Tree_MouseDown(object sender, MouseEventArgs e)
        {
            
            if (e.Button == MouseButtons.Right)
            {
                TreeNode node = this.Tree.GetNodeAt(e.Location);

                if (node == null)
                {
                    Viking.UI.State.SelectedObject = null; 
                    ContextMenu menu = new ContextMenu();

                    MenuItem menuItem = new MenuItem("New", OnNewStructureType);

                    menu.MenuItems.Add(menuItem);

                    this.ContextMenu = menu;

                    this.ContextMenu.Show(this, e.Location);
                }
            }
        }

        private void OnNewStructureType(object sender, EventArgs e)
        {
            StructureTypeObj newTypeObj = new StructureTypeObj();
            StructureType newType = new StructureType(newTypeObj);

            newType.ShowProperties();

            Store.StructureTypes.Add(newTypeObj);
            Store.StructureTypes.Save();

            this.Tree.AddObjects(new IUIObject[] { newType });

            Viking.UI.State.SelectedObject = newType;
        }

        
    }
}
