﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using System.Linq;
using System.Text;

using System.Diagnostics;
using System.ServiceModel;

using WebAnnotationModel.Service;
using WebAnnotationModel.Objects;

namespace WebAnnotationModel
{
    
    public class StructureLinkStore : StoreBaseWithKey<AnnotateStructuresClient, IAnnotateStructures, StructureLinkKey, StructureLinkObj, StructureLink>
    {
        public StructureLinkStore()
        {

        }

        public override void Init()
        {
            return; 
        }

        protected override AnnotateStructuresClient CreateProxy()
        {
            AnnotateStructuresClient proxy = new Service.AnnotateStructuresClient("Annotation.Service.Interfaces.IAnnotateStructures-Binary", State.EndpointAddress);
            proxy.ClientCredentials.UserName.UserName = State.UserCredentials.UserName;
            proxy.ClientCredentials.UserName.Password = State.UserCredentials.Password;
            return proxy;
        }

        protected override long[] ProxyUpdate(AnnotateStructuresClient proxy, StructureLink[] linkObjs)
        {
            proxy.UpdateStructureLinks(linkObjs);
            return new long[0];
        }
        
        protected override StructureLink ProxyGetByID(AnnotateStructuresClient proxy, StructureLinkKey ID)
        {
            throw new NotImplementedException();
        }

        protected override StructureLink[] ProxyGetByIDs(AnnotateStructuresClient proxy, StructureLinkKey[] IDs)
        {
            throw new NotImplementedException();
        }

        protected override System.Collections.Concurrent.ConcurrentDictionary<StructureLinkKey, StructureLinkObj> ProxyBeginGetBySection(AnnotateStructuresClient proxy, long SectionNumber, DateTime LastQuery, AsyncCallback callback, object asynchState)
        {
            throw new NotImplementedException();
        }

        protected override StructureLink[] ProxyGetBySectionCallback(out long TicksAtQueryExecute, out StructureLinkKey[] DeletedLocations, GetObjectBySectionCallbackState state, IAsyncResult result)
        {
            throw new NotImplementedException();
        }

        internal override StructureLinkObj[] InternalAdd(StructureLinkObj[] newObjs)
        {
            foreach (StructureLinkObj link in newObjs)
            {
                StructureObj SourceObj = Store.Structures.GetObjectByID(link.SourceID);
                StructureObj TargetObj = Store.Structures.GetObjectByID(link.TargetID);

                if (SourceObj != null)
                    SourceObj.AddLink(link);

                if (TargetObj != null)
                    TargetObj.AddLink(link); 
            }

            return base.InternalAdd(newObjs);
        }

        internal override void InternalDelete(StructureLinkKey[] linkKeys)
        {
            foreach (StructureLinkKey key in linkKeys)
            {
                StructureLinkObj link = Store.StructureLinks.GetObjectByID(key);
                if (link == null)
                    continue; 

                StructureObj SourceObj = Store.Structures.GetObjectByID(link.SourceID);
                StructureObj TargetObj = Store.Structures.GetObjectByID(link.TargetID);

                if (SourceObj != null)
                    SourceObj.RemoveLink(link);

                if (TargetObj != null)
                    TargetObj.RemoveLink(link);
            }

            base.InternalDelete(linkKeys);
        }
    }
}
