// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: nil -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : IRPruner.h
// Author       : Bradley C. Grimm
// Created      : 2009/05/15 11:52
// Copyright    : (C) 2009 University of Utah
// License      : GPLv2
// Description  : Used to prune uninteresting tiles.

#ifndef __IR_PRUNER_HXX__
#define __IR_PRUNER_HXX__

class IRPruner
{
public:
	static void PruneImages(std::list<the_text_t> &image_names,
                            std::vector<base_transform_t::Pointer> &transform,
                            const unsigned int &shrink_factor,
                            const double &pixel_spacing,
                            const bool &use_std_mask,
                            const unsigned int &tile_size,
                            const double &intensity_tolerance,
                            float overlap_percent = 1.0f);
};

#endif


