// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: nil -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*  
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// File         : UsageReader.h
// Author       : Bradley C. Grimm
// Created      : 2009/07/09
// Copyright    : (C) 2009 University of Utah
// License      : GPLv2
// Description  : 

#ifndef __USAGE_READER_H__
#define __USAGE_READER_H__

static void
detailed_usage(char ** argv, char *filename, char *tool_name)
{
  bool fail = false;

  cout << "Build Timestamp - " << __DATE__ << ", " << __TIME__ << endl;

  // Attempt to find detailed usage information.
  std::fstream fin;
  fin.open(filename, ios::in);

  if ( !fin.is_open() )
    fail = true;

  if ( !fail )
  {
    // Do a search for the information.
    bool found_tool = false;
    std::string str;
    while ( getline( fin, str ) )
    {
      found_tool |= (str.compare(tool_name) == 0);
      if ( found_tool )
      {
        if ( str.find("---------------") != str.npos )
          break;
        cout << str << endl;
      }
    }
  }

  fin.close();

  if ( fail )
    cerr << "Could not find detailed usage information." << endl;

  exit(1);
}

#endif


