#! /usr/bin/env python

#
#  This code reads in a stack of stos files, and transforms the annotated
#  points associated with each image into the new coordinate system
#

import string
import shutil
import sys
import transformPts
import os

#
#  ------- edit these vaiables before running!!!!!  --------
#
# max = the last image in the stom series.
max = 10 
# transx and transy are the offsets that come out of ir-stom (saved in
# ir-stom.out)  - 'grep minx ir-stom.out'
transx = 482
transy = 180
# if the data is in a different directory, set that here.
location = ""       #analysis data/"
# where is ir-stos-query located?
executable = "/scratch/liz/CRCNS/trunk/code/ir-tools_build/ir-stos-query"
#
#  -------------------- done --------------------------------
#

# example:
# run_transformPts.py analysis\ data/0001-0002.stos \
#                     analysis\ data/0002.txt analysis\ data/new_0002.txt
#                     0 0 200 200

#for index in range( max, 1, -1 ):
for index in range( max, 0, -1 ):

  prefix = "%04d" % ( index ) #max )
  orig_datafile = "%s%s.txt" % ( location, prefix )
  print "processing " + orig_datafile

  # copy the original file to a working copy
  copy_datafile = "copy_%s%s.txt" % ( location, prefix )
  #print "copying " + orig_datafile + " to " + copy_datafile
  shutil.copyfile( orig_datafile, copy_datafile )

  # make a temp file 
  tmp_datafile = "tmp_%s%s.txt" % ( location, prefix )
  #print tmp_datafile

  # make a copy of the datafile we can work with and not overwrite the
  # original one
  #if( index == max ):
  #  print "copying " + orig_datafile + " to " + stos_datafile
  #  orig_datafile.replace(" ", "\ ")
  #  shutil.copyfile( orig_datafile, stos_datafile )

  #
  #  rotate and translate all the points in each file
  #
  for stos_index in range( index, 1, -1 ):

     stosfile =  "%s%04d-%04d.stos" % (location, stos_index-1, stos_index)
     #print "stosfile: " + stosfile  

     #
     #  execute the other program
     #
     stosfile.replace(" ", "\ ")
     sys.argv = [ "junk", executable, stosfile, copy_datafile, tmp_datafile, 0, 0 ]
     if( stos_index == 2 ):
	sys.argv[5] = transx
	sys.argv[6] = transy
     #print sys.argv
     transformPts.main()
     #open(tmp_datafile,'w').close()

     #print "copying " + tmp_datafile + " to " + copy_datafile
     shutil.copyfile( tmp_datafile, copy_datafile )

  # end for stos....

  #
  #  just translate the first slice, don't rotate
  #
  if ( index == 1 ):
     stosfile =  ""
     #
     #  execute the other program
     #
     sys.argv = [ "junk", executable, stosfile, copy_datafile, tmp_datafile, 0, 0 ]
     #print sys.argv
     if( stos_index == 2 ):
	sys.argv[5] = transx
	sys.argv[6] = transy
     transformPts.main()

     #print "copying " + tmp_datafile + " to " + copy_datafile
     shutil.copyfile( tmp_datafile, copy_datafile )
  # end if
    
  stom_datafile = "stom_%s%s.txt" % ( location, prefix )
  stom_datafile.replace(" ", "\ ")
  #print "copying " + tmp_datafile + " to " + stom_datafile
  shutil.copyfile( tmp_datafile, stom_datafile )
  os.remove( tmp_datafile )
  os.remove( copy_datafile )

# end for index...

