// -*- Mode: c++; tab-width: 8; c-basic-offset: 2; indent-tabs-mode: t -*-
// NOTE: the first line of this file sets up source code indentation rules
// for Emacs; it is also a hint to anyone modifying this file.

/*
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


// File         : resolve_filename.cxx
// Author       : Pavel A. Koshevoy
// Created      : 2009/03/21
// Copyright    : (C) 2004-2009 University of Utah
// License      : GPLv2
// Description  : A helper function used to help the user find missing files
//		  that may have been moved to a different folder

#ifndef RESOLVE_FILENAME_HXX_
#define RESOLVE_FILENAME_HXX_

// the includes:
#include <utils/the_text.hxx>


namespace the
{
  namespace Qt
  {
    
    //----------------------------------------------------------------
    // resolve_filename
    // 
    // 1. Look for a given file.
    // 2. If not found, look for it in lookhere directory
    // 3. If not found, prompt the user to find the file
    // 4. If found, pass back the correct path and return true
    // 5. If not found return false
    // 
    extern bool
    resolve_filename(the_text_t & filename_utf8,
		     const the_text_t & lookhere_utf8 = the_text_t("."),
         bool clear_prev = false );
  }
}


#endif // RESOLVE_FILENAME_HXX_
